package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.ApplicationAccessDto;
import com.yice.webadmin.app.model.ApplicationAccess;
import com.yice.webadmin.app.model.KGManage;
import com.yice.webadmin.app.service.ApplicationAccessService;
import com.yice.webadmin.app.vo.ApplicationAccessVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 应用接入操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "应用接入管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/applicationAccess")
public class ApplicationAccessController {

    @Autowired
    private ApplicationAccessService applicationAccessService;

    /**
     * 新增应用接入数据。
     *
     * @param applicationAccessDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"applicationAccessDto.accessId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ApplicationAccessDto applicationAccessDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(applicationAccessDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ApplicationAccess applicationAccess = MyModelUtil.copyTo(applicationAccessDto, ApplicationAccess.class);
        applicationAccess = applicationAccessService.saveNew(applicationAccess);
        return ResponseResult.success(applicationAccess.getAccessId());
    }
    /**
     * 更新应用接入数据。
     *
     * @param applicationAccessDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ApplicationAccessDto applicationAccessDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(applicationAccessDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ApplicationAccess applicationAccess = MyModelUtil.copyTo(applicationAccessDto, ApplicationAccess.class);
        ApplicationAccess originalApplicationAccess = applicationAccessService.getById(applicationAccess.getAccessId());
        if (originalApplicationAccess == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        // 验证关联Id的数据合法性
        CallResult callResult = applicationAccessService.verifyRelatedData(applicationAccess, originalApplicationAccess);
        if (!callResult.isSuccess()) {
            return ResponseResult.errorFrom(callResult);
        }
        if (!applicationAccessService.update(applicationAccess, originalApplicationAccess)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除应用接入数据。
     *
     * @param accessId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long accessId) {
        if (MyCommonUtil.existBlankArgument(accessId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(accessId);
    }

    /**
     * 列出符合过滤条件的应用接入列表。
     *
     * @param applicationAccessDtoFilter 过滤对象。
     * @param orderParam           排序参数。
     * @param pageParam            分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ApplicationAccessVo>> list(
            @MyRequestBody ApplicationAccessDto applicationAccessDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ApplicationAccess applicationAccessFilter = MyModelUtil.copyTo(applicationAccessDtoFilter, ApplicationAccess.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ApplicationAccess.class);
        List<ApplicationAccess> applicationAccessList =
                applicationAccessService.getApplicationAccessListWithRelation(applicationAccessFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(applicationAccessList, ApplicationAccess.INSTANCE));
    }

    /**
     * 查看指定应用接入对象详情。
     *
     * @param accessId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ApplicationAccessVo> view(@RequestParam Long accessId) {
        ApplicationAccess applicationAccess = applicationAccessService.getByIdWithRelation(accessId, MyRelationParam.full());
        if (applicationAccess == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ApplicationAccessVo applicationAccessVo = ApplicationAccess.INSTANCE.fromModel(applicationAccess);
        return ResponseResult.success(applicationAccessVo);
    }

    private ResponseResult<Void> doDelete(Long accessId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ApplicationAccess originalApplicationAccess = applicationAccessService.getById(accessId);
        if (originalApplicationAccess == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!applicationAccessService.remove(accessId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
